# Frequency Response Script for Hantek DSO2000

## Requirements

python3  
pyserial  
numpy  
pyvisa  
optional: feeltech  

gnuplot  

On Linux, copy 99-hantek-dso.rules to /etc/udev/rules.d/

## h or --help:

    s; FStart=<Start Freq. f or fk or fM>
    e; FEnd=<End Freq. f or fk or fM>
    p; Points=<Number of measurements> optional add:<L> logarithmic
    c; ChannelSetup=<d0 / 0d / dr / rd> [d:DUT, r:REF, 0: One-channel mode]
    g; SignalGenerator=<type> [default: internal; options: fy32200, tinysa]
    l; LoadResistor [50Ohm dummy load?]
    d; DryRun [Do not save antything]
    i; SystemInfo [Also synchronizes time]
    n; NoAutoVolt [Do not set V/Div and SG amplitude]
    f; AdjustmentFile=<Filename>

## Example command lines

Measure from 4MHz to 10MHz take 20 pts.  
This is using the internal sg, assuming DUT on ch1 in 1-ch mode.

    python freqresp.py -s "4M" -e "10M" -p 20
    
Measure from 1kHz to 20MHz take 40 pts, use fy3200 sg.  
DUT d is on ch1, reference signal r is on ch2. -l 50Ohm load (doubles sg VPP).

    python freqresp.py -s "1k" -e "20M" -p 40 -c "dr" -g "fy3200" -l

Measure from 50MHz to 150MHz take 15 pts, use tinysa as sg.  
DUT (d) is on ch1, 1-ch mode. Use dat file for adjustment data  

    python freqresp.py -s "50M" -e "150M" -p 15  -g "tinysa" -c "d0" -f "tinysa_150.dat"
    
## Note
In 2-ch mode, make sure that "Measure"->"Setting"->"Source B" on you hantek is set correctly for getting FRR data (->phase).  
-i is synchroinzing the hantek clock with the PC-clock. If you just want this do: python freqresp.py -p 0 -i  
